/* $Header: reg.hv  1.6  91/06/07 10:53:58  Exp $ */

#define DEBUG 0

#define BELL '\07'

#define NIL (void *)0

#define TRUE 1
#define FALSE 0

/*
#ifndef bzero
#define bzero(s,n) memset((s),0,(n))
#endif
#ifndef bcopy
#define bcopy(s,d,l) memcpy((d),(s),(l))
#endif
*/

#define CHAR_STAFF 0x7f

typedef struct nfa_state *nfa_state_ptr;

/* NFAの状態 */
typedef struct nfa_state {
		char input[2];			/* 文字 */
		nfa_state_ptr transition[2];	/* 次の遷移 */
	} nfa_state;

typedef struct closure *closure_ptr;

/* 閉包のための構造 */
typedef struct closure {
		closure_ptr next;    /* 次へのチェイン */
		nfa_state_ptr state; /* NFAの状態 */
	} closure;

typedef struct dfa_state *dfa_state_ptr;

/* DFAの状態 */
typedef struct dfa_state {
		closure_ptr set_of_state;              /* 閉包へのポインタ */
		dfa_state_ptr transition[CHAR_STAFF];  /* 遷移(各文字について) */
		dfa_state_ptr next;                    /* 次のDFAの状態 */
		char condition;                        /* 状態 */
	} dfa_state;



#define EMPTY	(char)0
#define EPSILON	(char)1
#define GOAL	(char)2
